/*
 * Priklad pro demonstraci ukazatelu
 * Reseno zive na 6. prednasce PRPA
 * 29.10.2019
 */

#include <stdio.h>

int main(void)
{
	// promenna je v systemy charakterizovana
	// zejmena hodnotou a adresou
	// identifikator (jmeno) je symbol pro programatora
	char a = 10;
	// ukazatel (pointer) je take promenna, ktera
	// je typu "ukazatel na datovy typ XY" a hodnotou
	// je adresa jine promenne (pokud je spravne inicializovan)
	char *b = &a;
	// datovym typem ukazatele na promennou typu ukazatel
	// je "ukazatel na ukazatel"
	char **c = &b;
	// i promenne typu ukazatel maji svoji vlastni adresu
	printf("adresa a: %p\n", &a);
	printf("adresa b: %p\n", &b);
	printf("adresa c: %p\n", &c);
	// zatimco velikost promenne a je dana velikosti datoveho typu char
	// velikost promennych b a c je dana velikosti adresy procesoru (8B)
	printf("velikost a: %lu\n", sizeof(a));
	printf("velikost b: %lu\n", sizeof(b));
	printf("velikost c: %lu\n", sizeof(c));
	// zatimco promenna a obsahuje hodnotu primitivniho
	// datoveho typu, b a c obsahuji adresy
	printf("obsah a: %i\n", a);
	printf("obsah b: %p\n", (void *)b);
	printf("obsah c: %p\n", (void *)c);
	// pomoci dereferencniho operatoru lze pristupovat na prvek pameti
	// jehoz adresu obsahuje promenna typu ukazatel
	*b = 33;
	printf("obsah a prostrednictvim b: %i\n", *b);
	// derefence muze byt pochopitelne vicenasobna
	printf("obsah a prostrednictvim c: %i\n", *(*c)); // *c - adresa promenne a

	return 0;
}

