/*
 * Priklad pro demonstraci vztahu pole a ukazatele
 * Reseno zive na 6. prednasce PRPA
 * 29.10.2019
 */

#include <stdio.h>

int main()
{
	int panelak[] = {10, 20, 30};
	// ukazatel na prvni prvek pole
	int *x = &panelak[0];
	// ukazatel na cele pole
	int (*adresa)[3] = &panelak;

	for (int i = 0; i < 3; i++)
	{
		printf("p[%i] = %i, p[%i] = %i\n", i, panelak[i], i, *(x++));
	}
	// pozor na to, ze pri inkrementaci se meni obsah prommene x
	// takze po ukonceni cyklu ukazuje na adresu mimo pole! 
	x += -3;

	for (int i = 0; i < 3; i++)
	{
		printf("%i\n", *(x+i));
	}
	// adresa je ukazatel na triprvkove pole typu int, 
	// jeho inkrementaci se dostavame na prvni adresu za polem
	// tento koncept je dobre znat pro praci s 2D poli 
	for (int i = 0; i < 3; i++)
	{
		printf("%p\n", adresa+i);
	}

	return 0;
}

